// Schnittstelle der Klasse Konto
// ------------------------------
#include <vcl.h>
#include <math.h>
class Konto {
 private:
   int aKontostand;    // Kontostand in Cent
 protected:
   AnsiString kontoArt;
 public:
   Konto();
   Konto(int betrag);
   AnsiString getKontoArt();
   int getKontostand( );
   virtual  void buchen( int betrag );
   virtual int gibRestlaufzeit(void);
   virtual void vermindereLaufzeit(void);
   };

// Schnittstelle der Klasse Sparkonto
// ----------------------------------
class SparKonto: public Konto {
 protected:
  int aMindesteinlage;
 public:
  SparKonto( int mindesteinlage );
  void buchen( int betrag );
};

// Schnittstelle der Klasse Girokonto
// ----------------------------------
class GiroKonto: public Konto {
 protected:
  int aKreditLimit;
 public:
  GiroKonto( int kreditLimit );
  void buchen( int betrag );
};

// Schnittstelle der Klasse Festgeldkonto
// ----------------------------------
class Festgeldkonto : public Konto
{
public:
   Festgeldkonto(int p_AnlageBetrag, int pLaufzeit, float pZinssatz);
   void buchen(int betrag);
   int gibRestlaufzeit(void);
   void vermindereLaufzeit(void);
protected:
   int a_Restlaufzeit;
};

// Implementierung der Klasse Konto
// --------------------------------

Konto::Konto(){
  aKontostand = 0;
  kontoArt = "undefiniert";
}

Konto::Konto(int betrag){
  aKontostand = betrag;
  kontoArt = "undefiniert";
}

AnsiString Konto::getKontoArt(){
  return kontoArt;
}

int Konto::getKontostand( ){
  return aKontostand;
}

void Konto::buchen( int betrag ){
  aKontostand = aKontostand + betrag;
}

int Konto::gibRestlaufzeit(void){
return 0;
}
void Konto::vermindereLaufzeit(void){
;
}

// Implementierng der Klasse SparKonto
// ------------------------------------
SparKonto::SparKonto( int mindesteinlage ){
  aMindesteinlage = mindesteinlage;
  kontoArt = "Sparkonto";
  Konto::buchen(mindesteinlage);
}

void SparKonto::buchen( int betrag ){
  if (getKontostand() - aMindesteinlage + betrag >= 0)
      Konto::buchen(betrag);
}

// Implementierng der Klasse Girokonto
// ------------------------------------
GiroKonto::GiroKonto( int kreditLimit ){
  aKreditLimit = kreditLimit;
  kontoArt = "Girokonto";
}

void GiroKonto::buchen( int betrag ){
  if (getKontostand() + aKreditLimit + betrag >= 0)
      Konto::buchen(betrag);
}

// Implementierng der Klasse Festgeldkonto
// ------------------------------------

Festgeldkonto::Festgeldkonto(int p_AnlageBetrag, int pLaufzeit, float pZinssatz){
float Zinsen = (pZinssatz/100)*p_AnlageBetrag*(pLaufzeit/360.0);
int pBetrag = floor(Zinsen+0.5)+p_AnlageBetrag ;
Konto::buchen(pBetrag);
kontoArt = "Festgeldkonto";
a_Restlaufzeit =  pLaufzeit;
}

void Festgeldkonto::buchen(int betrag){
if(getKontostand()+ betrag >= 0 && a_Restlaufzeit <=0)
        Konto::buchen(betrag);
}

int Festgeldkonto::gibRestlaufzeit(void){
return a_Restlaufzeit;
}

void Festgeldkonto::vermindereLaufzeit(void){
if (a_Restlaufzeit>0)
        a_Restlaufzeit = a_Restlaufzeit - 1;
}




